local player_in_bed = 0
local bed_hight = 0.1
local time_change = 0.05

local function place_top(pos, node)
	local node = minetest.env:get_node(pos)
	if minetest.registered_nodes[node.name].buildable_to == true then
		node.name = "bed:bed_top"
		minetest.env:set_node(pos, node)
	end
end

local function remove_top(pos)
	local node = minetest.env:get_node(pos)
	if node.name == "bed:bed_top" or node.name == "bed:bed_bottom" then
		minetest.env:remove_node(pos)
	end
end

minetest.register_node("bed:bed_bottom", {
	description = "Bed",
	drawtype = "nodebox",
	tiles = {"wool_dark_grey.png"},
	paramtype = "light",
	paramtype2 = "facedir",
	stack_max = 1,
	groups = {snappy=1,choppy=2,oddly_breakable_by_hand=2,flammable=3},
	sounds = default.node_sound_wood_defaults(),
	node_box = {
		type = "fixed",
		fixed = {
					-- bed
					{-0.5, -0.5, -0.5, 0.5, -0.5+bed_hight, 0.5},
				}
	},
	selection_box = {
		type = "fixed",
		fixed = {
					{-0.5, -0.5, -0.5, 0.5, -0.5+bed_hight, 0.5},
				}
	},
	
	
	on_construct = function(pos)
		pos.x = math.floor(pos.x+0.5)
		pos.y = math.floor(pos.y+0.5)
		pos.z = math.floor(pos.z+0.5)
		local node = minetest.env:get_node(pos)
			local param2 = node.param2
			if param2 == 0 then
				pos.z = pos.z+1
				place_top(pos, node)
			elseif param2 == 1 then
				pos.x = pos.x+1
				place_top(pos, node)
			elseif param2 == 2 then
				pos.z = pos.z-1
				place_top(pos, node)
			elseif param2 == 3 then
				pos.x = pos.x-1
				place_top(pos, node)
			end
	end,
	
	on_destruct = function(pos)
		pos.x = math.floor(pos.x+0.5)
		pos.y = math.floor(pos.y+0.5)
		pos.z = math.floor(pos.z+0.5)
		local node = minetest.env:get_node(pos)
			local param2 = node.param2
			if param2 == 0 then
				pos.z = pos.z+1
				remove_top(pos)
			elseif param2 == 1 then
				pos.x = pos.x+1
				remove_top(pos)
			elseif param2 == 2 then
				pos.z = pos.z-1
				remove_top(pos)
			elseif param2 == 3 then
				pos.x = pos.x-1
				remove_top(pos)
			end
	end,
})

minetest.register_node("bed:bed_top", {
	drawtype = "nodebox",
	tiles = {"wool_dark_grey.png"},
	paramtype = "light",
	paramtype2 = "facedir",
	groups = {snappy=1,choppy=2,oddly_breakable_by_hand=2,flammable=3},
	sounds = default.node_sound_wood_defaults(),
	node_box = {
		type = "fixed",
		fixed = {
					-- bed
					{-0.5, -0.5, -0.5, 0.5, -0.5+bed_hight, 0.5},
				}
	},
	selection_box = {
		type = "fixed",
		fixed = {
					{0, 0, 0, 0, 0, 0},
				}
	},
})

minetest.register_alias("bed:bed", "bed:bed_bottom")

minetest.register_craft({
	output = "bed:bed",
	recipe = {
		{"wool:white", "wool:white", "wool:white", },
	}
})

minetest.register_craft({
	output = "bed:bed",
	recipe = {
		{"group:wool", "group:wool", "group:wool", },
	}
})

minetest.register_craft({
	output = "bed:bed",
	recipe = {
		{"default:paper", "default:papyrus", "default:papyrus", },
	}
})

local timer = 0
minetest.register_globalstep(function(dtime)
	if timer<3 then
		timer = timer+dtime
		return
	end
	timer = 0
	player_in_bed = 0
	
	for _,player in ipairs(minetest.get_connected_players()) do
		local pos = player:getpos()
		pos.x = math.floor(pos.x+0.5)
		pos.y = math.floor(pos.y+0.5-bed_hight)
		pos.z = math.floor(pos.z+0.5)
		local n = minetest.env:get_node(pos)
		if n.name == "bed:bed_bottom" or n.name == "bed:bed_top" then
			player_in_bed = player_in_bed + 1
		end
	end

	local players = #minetest.get_connected_players()
	if players >= player_in_bed and players ~= 0 and player_in_bed ~= 0 then
			local timeofday = minetest.env:get_timeofday()
			if (time_change * (player_in_bed/players)) >= 0.01 then
				local new_time = timeofday + (time_change * (player_in_bed/players))
				while new_time >= 1 do
					new_time = new_time - 1
				end
				minetest.env:set_timeofday(new_time)
				if players > 1 then
					minetest.chat_send_all(""..player_in_bed.." of "..players.." players are sleeping.")
				else
--					minetest.chat_send_all("Good Night!")
				end
			end
	end

end)

if minetest.setting_get("log_mods") then
	minetest.log("action", "bed loaded")
end